package SesameGUI;

import java.awt.*;

import java.awt.event.*;

import javax.swing.*;

import java.util.Enumeration;

import javax.swing.tree.*;

import java.io.PrintWriter;

import java.io.FileWriter;

import java.io.FileReader;

import java.io.IOException;

import java.io.BufferedWriter;

import java.io.StreamTokenizer;

import java.io.DataInputStream;

import java.io.File;

import java.io.InputStreamReader;

import java.io.BufferedReader;

import javax.swing.JToolBar.*;

import java.util.Calendar;

import javax.swing.ImageIcon;



/**

 * A basic JFC 1.1 based application.

 */

public class JFrameSesame extends javax.swing.JFrame

{

  String PROJECT_NAME = null;

  boolean WARNING = false;

  boolean NOWINDOWS = false;

  boolean MIXWINDOWS = false;

  JDialogFilter filterDialog = new JDialogFilter();

  JFileChooser fileChooser = new JFileChooser();

  public DefaultMutableTreeNode ACTIVE_OBJECT_PLOTED = null;

  JDialogManualWindow configManualWin = new JDialogManualWindow(new Frame(),true);

  JDialogAutoWindow configAutoWin = new JDialogAutoWindow(new Frame(),true);

  JDialogGeneralConfig configGeneral = new JDialogGeneralConfig(new Frame(),true);

  JFrameConsole consol = new JFrameConsole("Console output");

  PreviewWavePanel previewPane = new PreviewWavePanel();

  private ProcessingParameters processingParameters = new ProcessingParameters ();

  static SesameObject UF = new SesameObject("Unasigned_file");

  static boolean FIRSTSHOW = true;

  static int XDIF1=0;

  static int YDIF1=229;

  static {

  UF.setType(3);

  }

  static DefaultMutableTreeNode root  = new DefaultMutableTreeNode("New_Project");

  static DefaultMutableTreeNode unasignedFile = new DefaultMutableTreeNode(UF);

  static DefaultTreeModel       model = new DefaultTreeModel(root);

  static int indSite = 0;



  static {

    unasignedFile.setAllowsChildren(true);

    model.insertNodeInto(unasignedFile, root, 0);

  }

  DragDropTree myJTree = new DragDropTree(model);

    

	public JFrameSesame()

	{

		// This code is automatically generated by Visual Cafe when you add

		// components to the visual environment. It instantiates and initializes

		// the components. To modify the code, only use code syntax that matches

		// what Visual Cafe can generate, or Visual Cafe may be unable to back

		// parse your Java file into its visual environment.

		//{{INIT_CONTROLS

		setJMenuBar(JMenuBar1);
		setTitle("JSesame Version 1.08");
		setDefaultCloseOperation(javax.swing.JFrame.DO_NOTHING_ON_CLOSE);

		getContentPane().setLayout(new BorderLayout(0,0));

		setSize(1061,622);

		setVisible(false);

		JPanel2.setLayout(new FlowLayout(FlowLayout.LEFT,0,0));

		getContentPane().add(BorderLayout.NORTH, JPanel2);

		JPanel2.setBounds(0,0,1061,15);

		JToolBar1.setAlignmentY(0.222222F);

		JPanel2.add(JToolBar1);

		JToolBar1.setBounds(0,0,144,15);

		newButton.setActionCommand("jbutton");

		newButton.setDefaultCapable(false);

		newButton.setToolTipText("Create a new document");

		newButton.setMnemonic((int)'N');

		JToolBar1.add(newButton);

		newButton.setBounds(2,2,35,11);

		openButton.setActionCommand("jbutton");

		openButton.setDefaultCapable(false);

		openButton.setToolTipText("Open an existing document");

		openButton.setMnemonic((int)'O');

		JToolBar1.add(openButton);

		openButton.setBounds(37,2,35,11);

		saveButton.setActionCommand("jbutton");

		saveButton.setDefaultCapable(false);

		saveButton.setToolTipText("Save the active document");

		saveButton.setMnemonic((int)'S');

		JToolBar1.add(saveButton);

		saveButton.setBounds(72,2,35,11);

		aboutButton.setActionCommand("jbutton");

		aboutButton.setDefaultCapable(false);

		aboutButton.setToolTipText("Display program information, version number and copyright");

		aboutButton.setMnemonic((int)'A');

		JToolBar1.add(aboutButton);

		aboutButton.setBounds(107,2,35,11);

		JPanel1.setLayout(null);

		getContentPane().add(BorderLayout.CENTER, JPanel1);

		JPanel1.setBounds(0,15,1061,607);

		JPanel1.add(JEditSite);

		JEditSite.setBounds(564,30,216,24);

		JPanel1.add(JEditOutFile);

		JEditOutFile.setBounds(564,63,216,24);

		JLabelSiteName.setText("Site Name:");

		JPanel1.add(JLabelSiteName);

		JLabelSiteName.setBounds(444,30,108,24);

		JLabelOutFile.setText("Output File Name:");

		JPanel1.add(JLabelOutFile);

		JLabelOutFile.setBounds(444,63,120,24);

		JLabelNWin.setText("Number of Windows:");

		JPanel1.add(JLabelNWin);

		JLabelNWin.setBounds(444,99,144,24);

		JLabelLWin.setText("Windows length:");

		JPanel1.add(JLabelLWin);

		JLabelLWin.setBounds(444,130,120,24);

		JButtonInsertDataFile.setText("Insert DataFile");

		JButtonInsertDataFile.setActionCommand("jbutton");

		JPanel1.add(JButtonInsertDataFile);

		JButtonInsertDataFile.setBounds(12,17,132,24);

		JButtonInsertSite.setText("Insert Site");

		JButtonInsertSite.setActionCommand("jbutton");

		JPanel1.add(JButtonInsertSite);

		JButtonInsertSite.setBounds(12,53,132,24);

		JButtonRemove.setText("Remove");

		JButtonRemove.setActionCommand("jbutton");

		JPanel1.add(JButtonRemove);

		JButtonRemove.setBounds(12,89,132,24);

		JButtonViewOutput.setText("View Output");

		JButtonViewOutput.setActionCommand("jbutton");

		JPanel1.add(JButtonViewOutput);

		JButtonViewOutput.setBounds(12,161,132,24);

		JButtonPlot.setText("Plot Traces");

		JButtonPlot.setActionCommand("jbutton");

		JPanel1.add(JButtonPlot);

		JButtonPlot.setBounds(12,125,132,24);

		JScrollPane2.setOpaque(true);

		JPanel1.add(JScrollPane2);

		JScrollPane2.setBounds(170,17,252,168);

		JPanel3.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));

		JScrollPane2.getViewport().add(JPanel3);

		JPanel3.setBackground(java.awt.Color.white);

		JPanel3.setBounds(0,0,248,164);

		JEditNumberWin.setText("jlabel");

		JPanel1.add(JEditNumberWin);

		JEditNumberWin.setBackground(java.awt.Color.lightGray);

		JEditNumberWin.setBounds(612,99,48,24);

		JEditLengthWin.setText("jlabel");

		JPanel1.add(JEditLengthWin);

		JEditLengthWin.setBackground(java.awt.Color.lightGray);

		JEditLengthWin.setBounds(612,130,48,24);

		//JPanel1.add(JScrollPane1);

//		JScrollPane1.setBounds(12,197,1000,388);

		JCheckBoxWindowSel.setText("Manual Window Selection");

		JCheckBoxWindowSel.setActionCommand("Manual Window Selection");

		JPanel1.add(JCheckBoxWindowSel);

		JCheckBoxWindowSel.setBounds(444,-3,204,28);

		ProcessTimeLabel.setText("jlabel");

		JPanel1.add(ProcessTimeLabel);

		ProcessTimeLabel.setBackground(java.awt.Color.lightGray);

		ProcessTimeLabel.setBounds(612,161,144,24);

		JLabelProcess.setText("Last Processing Time:");

		JPanel1.add(JLabelProcess);

		JLabelProcess.setBounds(444,161,132,24);

		//$$ JMenuBar1.move(0,0);

		fileMenu.setText("Project");

		fileMenu.setActionCommand("File");

		fileMenu.setBorderPainted(false);

		fileMenu.setMnemonic((int)'F');

		JMenuBar1.add(fileMenu);

		newItem.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

		newItem.setText("New");

		newItem.setActionCommand("New");

		newItem.setBorderPainted(false);

		newItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_N, java.awt.Event.CTRL_MASK));

		newItem.setMnemonic((int)'N');

		fileMenu.add(newItem);

		openItem.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

		openItem.setText("Open...");

		openItem.setActionCommand("Open...");

		openItem.setBorderPainted(false);

		openItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.Event.CTRL_MASK));

		openItem.setMnemonic((int)'O');

		fileMenu.add(openItem);

		saveItem.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

		saveItem.setText("Save");

		saveItem.setActionCommand("Save");

		saveItem.setBorderPainted(false);

		saveItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.Event.CTRL_MASK));

		saveItem.setMnemonic((int)'S');

		fileMenu.add(saveItem);

		saveAsItem.setText("Save As...");

		saveAsItem.setActionCommand("Save As...");

		saveAsItem.setBorderPainted(false);

		saveAsItem.setMnemonic((int)'A');

		fileMenu.add(saveAsItem);

		fileMenu.add(JSeparator1);

		exitItem.setText("Exit");

		exitItem.setActionCommand("Exit");

		exitItem.setBorderPainted(false);

		exitItem.setMnemonic((int)'X');

		fileMenu.add(exitItem);

		configMenu.setText("Config");

		configMenu.setActionCommand("Edit");

		configMenu.setBorderPainted(false);

		configMenu.setMnemonic((int)'E');

		JMenuBar1.add(configMenu);

		manualWindowItem.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

		manualWindowItem.setText("Manual Window Selection");

		manualWindowItem.setActionCommand("Cut");

		manualWindowItem.setBorderPainted(false);

		manualWindowItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_M, java.awt.Event.CTRL_MASK));

		manualWindowItem.setMnemonic((int)'T');

		configMenu.add(manualWindowItem);

		automaticWindowItem.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

		automaticWindowItem.setText("Automatic Window Selection");

		automaticWindowItem.setActionCommand("Copy");

		automaticWindowItem.setBorderPainted(false);

		automaticWindowItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_A, java.awt.Event.CTRL_MASK));

		automaticWindowItem.setMnemonic((int)'C');

		configMenu.add(automaticWindowItem);

		processingItem.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

		processingItem.setText("Processing Parameters");

		processingItem.setActionCommand("Paste");

		processingItem.setBorderPainted(false);

		processingItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_P, java.awt.Event.CTRL_MASK));

		processingItem.setMnemonic((int)'P');

		configMenu.add(processingItem);

		filterItem.setText("Filter options");

		filterItem.setActionCommand("Filter options");

		filterItem.setBorderPainted(false);

		filterItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F, java.awt.Event.CTRL_MASK));

		configMenu.add(filterItem);

		generalItem.setText("General Parameters");

		generalItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_G, java.awt.Event.CTRL_MASK));

		configMenu.add(generalItem);

		processMenu.setText("Processing");

		processMenu.setActionCommand("Processing");

		processMenu.setBorderPainted(false);

		JMenuBar1.add(processMenu);

		winSelectMenu.setText("Automatic Windows Selection");

		winSelectMenu.setActionCommand("Automatic Windows Selection");

		winSelectMenu.setBorderPainted(false);

		processMenu.add(winSelectMenu);

		winNoFilterItem.setText("Without filter");

		winNoFilterItem.setActionCommand("Automatic Window Selection");

		winNoFilterItem.setBorderPainted(false);

		winNoFilterItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_W, java.awt.Event.CTRL_MASK));

		winSelectMenu.add(winNoFilterItem);

		winFilterItem.setText("With filter");

		winFilterItem.setActionCommand("With filter");

		winFilterItem.setBorderPainted(false);

		winSelectMenu.add(winFilterItem);

		winBothItem.setText("Common windows (Filter/no-Filter)");

		winBothItem.setActionCommand("common Filter/no-Filter");

		winBothItem.setBorderPainted(false);

		winSelectMenu.add(winBothItem);

		keepFirstWinforAllItem.setText("Same windows for several files");

		keepFirstWinforAllItem.setActionCommand("Keep First for All");

		keepFirstWinforAllItem.setBorderPainted(false);

		winSelectMenu.add(keepFirstWinforAllItem);

		filterMenuItem.setText("Show Filtered Traces");

		filterMenuItem.setActionCommand("Apply Selected Filter");

		filterMenuItem.setBorderPainted(false);

		processMenu.add(filterMenuItem);

		spectralRatioMenuItem.setText("H/V Spectral Ratio");

		spectralRatioMenuItem.setActionCommand("H/V Spectral Ratio");

		spectralRatioMenuItem.setBorderPainted(false);

		spectralRatioMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_R, java.awt.Event.CTRL_MASK));

		processMenu.add(spectralRatioMenuItem);

		helpMenu.setText("Help");

		helpMenu.setActionCommand("Help");

		helpMenu.setBorderPainted(false);

		helpMenu.setMnemonic((int)'H');

		JMenuBar1.add(helpMenu);

		aboutItem.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

		aboutItem.setText("About...");

		aboutItem.setActionCommand("About...");

		aboutItem.setBorderPainted(false);

		aboutItem.setMnemonic((int)'A');

		helpMenu.add(aboutItem);

		generalItem.setActionCommand("General Parameters");

		generalItem.setBorderPainted(false);



    logo.setIcon(new ImageIcon (new String ("images/logo.gif")));

    logo.setBounds(800 , 5 , 141 , 144);

    JPanel1.add(logo);

		//}}

        

		//{{INIT_MENUS

		//}}



		//{{REGISTER_LISTENERS

		SymWindow aSymWindow = new SymWindow();

		this.addWindowListener(aSymWindow);

		SymAction lSymAction = new SymAction();

		openItem.addActionListener(lSymAction);

		saveItem.addActionListener(lSymAction);

		exitItem.addActionListener(lSymAction);

		aboutItem.addActionListener(lSymAction);

		openButton.addActionListener(lSymAction);

		saveButton.addActionListener(lSymAction);

		aboutButton.addActionListener(lSymAction);

		JButtonInsertDataFile.addActionListener(lSymAction);

		JButtonInsertSite.addActionListener(lSymAction);

		JButtonRemove.addActionListener(lSymAction);

		JButtonPlot.addActionListener(lSymAction);

		saveAsItem.addActionListener(lSymAction);

		JEditSite.addActionListener(lSymAction);

		SymKey aSymKey = new SymKey();

		JEditSite.addKeyListener(aSymKey);

		SymFocus aSymFocus = new SymFocus();

		JEditSite.addFocusListener(aSymFocus);

		JEditOutFile.addKeyListener(aSymKey);

		SymItem lSymItem = new SymItem();

		JCheckBoxWindowSel.addItemListener(lSymItem);

		newItem.addActionListener(lSymAction);

		newButton.addActionListener(lSymAction);

		manualWindowItem.addActionListener(lSymAction);

		winNoFilterItem.addActionListener(lSymAction);

		automaticWindowItem.addActionListener(lSymAction);

		generalItem.addActionListener(lSymAction);

    processingItem.addActionListener(lSymAction);

		spectralRatioMenuItem.addActionListener(lSymAction);

		SymComponent aSymComponent = new SymComponent();

		this.addComponentListener(aSymComponent);

		JButtonViewOutput.addActionListener(lSymAction);

		filterItem.addActionListener(lSymAction);

		filterMenuItem.addActionListener(lSymAction);

		winFilterItem.addActionListener(lSymAction);

		winBothItem.addActionListener(lSymAction);

		keepFirstWinforAllItem.addActionListener(lSymAction);

		JEditOutFile.addFocusListener(aSymFocus);

		//}}

		myJTree.setParent(this);

		this.JPanel3.add((Component)myJTree);

    //getContentPane().add(BorderLayout.CENTER,JScrollPane1 );

    //JScrollPane1.getViewport().add(previewPane);

    JPanel1.add(previewPane);

		previewPane.setBounds(12,197,1069,450);

		previewPane.setFrame(this);

        previewPane.reset();

        //this.JScrollPane1.getViewport().add(previewPane);

		this.resetProject("New_Project");

		ImageIcon newIcon = new ImageIcon(new String ("images/new.gif"));

	    ImageIcon openIcon = new ImageIcon(new String ("images/open.gif"));

	    ImageIcon saveIcon = new ImageIcon(new String ("images/save.gif"));

	    ImageIcon aboutIcon = new ImageIcon(new String ("images/about.gif"));

	    newButton.setIcon(newIcon);

	    openButton.setIcon(openIcon);

	    saveButton.setIcon(saveIcon);

	    aboutButton.setIcon(aboutIcon);

      OpenGeneralConfigFile();

	}



    /**

     * Creates a new instance of JFrame1 with the given title.

     * @param sTitle the title for the new frame.

     * @see #JFrame1()

     */

	public JFrameSesame(String sTitle)

	{

		this();

		setTitle(sTitle);

	}

	

	/**

	 * The entry point for this application.

	 * Sets the Look and Feel to the System Look and Feel.

	 * Creates a new JFrame1 and makes it visible.

	 */

	static public void main(String args[])

	{

		try {

		    // Add the following code if you want the Look and Feel

		    // to be set to the Look and Feel of the native system.

		    /*

		    try {

		        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());

		    } 

		    catch (Exception e) { 

		    }

		    */



			//Create a new instance of our application's frame, and make it visible.

      JFrameSesame    frm;

      frm = new JFrameSesame();



      if (args.length > 0)

        frm.setDecimation (Integer.parseInt(args [0]));

        

			frm.setVisible(true);

		} 

		catch (Throwable t) {

			t.printStackTrace();

			//Ensure the application exits with an error condition.

			System.exit(1);

		}

	}



    /**

     * Notifies this component that it has been added to a container

     * This method should be called by <code>Container.add</code>, and 

     * not by user code directly.

     * Overridden here to adjust the size of the frame if needed.

     * @see java.awt.Container#removeNotify

     */

	public void addNotify()

	{

		// Record the size of the window prior to calling parents addNotify.

		Dimension size = getSize();

		

		super.addNotify();

		

		if (frameSizeAdjusted)

			return;

		frameSizeAdjusted = true;

		

		// Adjust size of frame according to the insets and menu bar

		javax.swing.JMenuBar menuBar = getRootPane().getJMenuBar();

		int menuBarHeight = 0;

		if (menuBar != null)

		    menuBarHeight = menuBar.getPreferredSize().height;

		Insets insets = getInsets();

		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height + menuBarHeight);

	}



	// Used by addNotify

	boolean frameSizeAdjusted = false;



	//{{DECLARE_CONTROLS

	javax.swing.JPanel JPanel2 = new javax.swing.JPanel();

	javax.swing.JToolBar JToolBar1 = new javax.swing.JToolBar();

	javax.swing.JButton newButton = new javax.swing.JButton();

	javax.swing.JButton openButton = new javax.swing.JButton();

	javax.swing.JButton saveButton = new javax.swing.JButton();

	javax.swing.JButton aboutButton = new javax.swing.JButton();

	javax.swing.JPanel JPanel1 = new javax.swing.JPanel();

	javax.swing.JTextField JEditSite = new javax.swing.JTextField();

	javax.swing.JTextField JEditOutFile = new javax.swing.JTextField();

	javax.swing.JLabel JLabelSiteName = new javax.swing.JLabel();

	javax.swing.JLabel JLabelOutFile = new javax.swing.JLabel();

	javax.swing.JLabel JLabelNWin = new javax.swing.JLabel();

	javax.swing.JLabel JLabelLWin = new javax.swing.JLabel();

	javax.swing.JButton JButtonInsertDataFile = new javax.swing.JButton();

	javax.swing.JButton JButtonInsertSite = new javax.swing.JButton();

	javax.swing.JButton JButtonRemove = new javax.swing.JButton();

	javax.swing.JButton JButtonViewOutput = new javax.swing.JButton();

	javax.swing.JButton JButtonPlot = new javax.swing.JButton();

	javax.swing.JScrollPane JScrollPane2 = new javax.swing.JScrollPane();

	javax.swing.JPanel JPanel3 = new javax.swing.JPanel();

	javax.swing.JLabel JEditNumberWin = new javax.swing.JLabel();

	javax.swing.JLabel JEditLengthWin = new javax.swing.JLabel();

//	javax.swing.JScrollPane JScrollPane1 = new javax.swing.JScrollPane();

	javax.swing.JCheckBox JCheckBoxWindowSel = new javax.swing.JCheckBox();

	javax.swing.JLabel ProcessTimeLabel = new javax.swing.JLabel();

	javax.swing.JLabel JLabelProcess = new javax.swing.JLabel();

	javax.swing.JMenuBar JMenuBar1 = new javax.swing.JMenuBar();

	javax.swing.JMenu fileMenu = new javax.swing.JMenu();

	javax.swing.JMenuItem newItem = new javax.swing.JMenuItem();

	javax.swing.JMenuItem openItem = new javax.swing.JMenuItem();

	javax.swing.JMenuItem saveItem = new javax.swing.JMenuItem();

	javax.swing.JMenuItem saveAsItem = new javax.swing.JMenuItem();

	javax.swing.JSeparator JSeparator1 = new javax.swing.JSeparator();

	javax.swing.JMenuItem exitItem = new javax.swing.JMenuItem();

	javax.swing.JMenu configMenu = new javax.swing.JMenu();

	javax.swing.JMenuItem manualWindowItem = new javax.swing.JMenuItem();

	javax.swing.JMenuItem automaticWindowItem = new javax.swing.JMenuItem();

	javax.swing.JMenuItem processingItem = new javax.swing.JMenuItem();

	javax.swing.JMenuItem filterItem = new javax.swing.JMenuItem();

	javax.swing.JMenuItem generalItem = new javax.swing.JMenuItem();

	javax.swing.JMenu processMenu = new javax.swing.JMenu();

	javax.swing.JMenu winSelectMenu = new javax.swing.JMenu();

	javax.swing.JMenuItem winNoFilterItem = new javax.swing.JMenuItem();

	javax.swing.JMenuItem winFilterItem = new javax.swing.JMenuItem();

	javax.swing.JMenuItem winBothItem = new javax.swing.JMenuItem();

	javax.swing.JMenuItem keepFirstWinforAllItem = new javax.swing.JMenuItem();

	javax.swing.JMenuItem filterMenuItem = new javax.swing.JMenuItem();

	javax.swing.JMenuItem spectralRatioMenuItem = new javax.swing.JMenuItem();

	javax.swing.JMenu helpMenu = new javax.swing.JMenu();

	javax.swing.JMenuItem aboutItem = new javax.swing.JMenuItem();

  javax.swing.JLabel logo = new javax.swing.JLabel();

	//}}



	//{{DECLARE_MENUS

	//}}



	void exitApplication()

	{

		try {

	    	// Beep

	    	Toolkit.getDefaultToolkit().beep();

	    	// Show a confirmation dialog

	    	int reply = JOptionPane.showConfirmDialog(this, 

	    	                                          "Do you really want to exit?", 

	    	                                          "Sesame Application - Exit" , 

	    	                                          JOptionPane.YES_NO_OPTION, 

	    	                                          JOptionPane.QUESTION_MESSAGE);

			// If the confirmation was affirmative, handle exiting.

			if (reply == JOptionPane.YES_OPTION)

			{

		    	this.setVisible(false);    // hide the Frame

		    	this.dispose();            // free the system resources

		    	System.exit(0);            // close the application

			}

		} catch (Exception e) {

		}

	}



	class SymWindow extends java.awt.event.WindowAdapter

	{

		public void windowClosing(java.awt.event.WindowEvent event)

		{

			Object object = event.getSource();

			if (object == JFrameSesame.this)

				JFrameSesame_windowClosing(event);

		}

	}



	void JFrameSesame_windowClosing(java.awt.event.WindowEvent event)

	{

		// to do: code goes here.

			 

		JFrameSesame_windowClosing_Interaction1(event);

	}



	void JFrameSesame_windowClosing_Interaction1(java.awt.event.WindowEvent event) {

		try {

			this.exitApplication();

		} catch (Exception e) {

		}

	}



	class SymAction implements java.awt.event.ActionListener

	{

		public void actionPerformed(java.awt.event.ActionEvent event)

		{

			Object object = event.getSource();

			if (object == openItem)

				openItem_actionPerformed(event);

			else if (object == saveItem)

				saveItem_actionPerformed(event);

			else if (object == exitItem)

				exitItem_actionPerformed(event);

			else if (object == aboutItem)

				aboutItem_actionPerformed(event);

			else if (object == openButton)

				openButton_actionPerformed(event);

			else if (object == saveButton)

				saveButton_actionPerformed(event);

			else if (object == aboutButton)

				aboutButton_actionPerformed(event);

			else if (object == JButtonInsertDataFile)

				JButtonInsertDataFile_actionPerformed(event);

			else if (object == JButtonInsertSite)

				JButtonInsertSite_actionPerformed(event);

			else if (object == JButtonRemove)

				JButtonRemove_actionPerformed(event);

			else if (object == JButtonPlot)

				JButtonPlot_actionPerformed(event);

			else if (object == saveAsItem)

				saveAsItem_actionPerformed(event);

			else if (object == newItem)

				newItem_actionPerformed(event);

			else if (object == newButton)

				newButton_actionPerformed(event);

			else if (object == manualWindowItem)

				manualWindowItem_actionPerformed(event);

			else if (object == winNoFilterItem)

				winNoFilterItem_actionPerformed(event);

			else if (object == automaticWindowItem)

				automaticWindowItem_actionPerformed(event);

      else if (object == processingItem)

				processingItem_actionPerformed(event);

			else if (object == generalItem)

				generalItem_actionPerformed(event);

			else if (object == spectralRatioMenuItem)

				spectralRatioMenuItem_actionPerformed(event);

			else if (object == JButtonViewOutput)

				JButtonViewOutput_actionPerformed(event);

			else if (object == filterItem)

				filterItem_actionPerformed(event);

			else if (object == filterMenuItem)

				filterMenuItem_actionPerformed(event);

			else if (object == winFilterItem)

				winFilterItem_actionPerformed(event);

			else if (object == winBothItem)

				winBothItem_actionPerformed(event);

			else if (object == keepFirstWinforAllItem)

				keepFirstWinforAllItem_actionPerformed(event);

		}

	}



	void openItem_actionPerformed(java.awt.event.ActionEvent event)

	{

		// Open a project			 

		fileChooser.setMultiSelectionEnabled(false);

		fileChooser.showOpenDialog(this);

		File file;

		if( (file=fileChooser.getSelectedFile())!=null ) {

		 OpenSesameProject(file.getAbsolutePath());

		 PROJECT_NAME = file.getAbsolutePath();

		}

	}

	



	void saveItem_actionPerformed(java.awt.event.ActionEvent event)

	{

		// Save Project

		if( PROJECT_NAME != null ) { 

		    SaveSesameProject(PROJECT_NAME);

		    return;

		}

		fileChooser.setMultiSelectionEnabled(false);

		fileChooser.showSaveDialog(this);

		File file;

		if( (file=fileChooser.getSelectedFile())!=null ) {

		 SaveSesameProject(file.getAbsolutePath());

		 PROJECT_NAME = file.getAbsolutePath();

		}	 		

	}

	



	void exitItem_actionPerformed(java.awt.event.ActionEvent event)

	{

		// to do: code goes here.

			 

		exitItem_actionPerformed_Interaction1(event);

	}



	void exitItem_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {

		try {

			this.exitApplication();

		} catch (Exception e) {

		}

	}



	void aboutItem_actionPerformed(java.awt.event.ActionEvent event)

	{

		// to do: code goes here.

			 

		aboutItem_actionPerformed_Interaction1(event);

	}



	void aboutItem_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {

		try {

			// JAboutDialog Create with owner and show as modal

			{

				JAboutDialog JAboutDialog1 = new JAboutDialog(this);

				JAboutDialog1.setModal(true);

				JAboutDialog1.show();

			}

		} catch (Exception e) {

		}

	}



	void openButton_actionPerformed(java.awt.event.ActionEvent event)

	{

		// open a project.			 

	    openItem_actionPerformed(event);	 

	}





	void saveButton_actionPerformed(java.awt.event.ActionEvent event)

	{

		// Save Project

		saveItem_actionPerformed(event);

	}

	



	void aboutButton_actionPerformed(java.awt.event.ActionEvent event)

	{

		// to do: code goes here.

			 

		aboutButton_actionPerformed_Interaction1(event);

	}



	void aboutButton_actionPerformed_Interaction1(java.awt.event.ActionEvent event) {

		try {

			// JAboutDialog Create with owner and show as modal

			{

				JAboutDialog JAboutDialog1 = new JAboutDialog(this);

				JAboutDialog1.setModal(true);

				JAboutDialog1.show();

			}

		} catch (Exception e) {

		}

	}



	void JButtonInsertDataFile_actionPerformed(java.awt.event.ActionEvent event)

	{

		// Insert a data file into the project

		fileChooser.setMultiSelectionEnabled(true);

		int outchose = fileChooser.showOpenDialog(this);

		File[] listFile;

		int i=0;

		if( (listFile=fileChooser.getSelectedFiles())==null || outchose!=0 ) return;

		int n = listFile.length;

		while(i< n) {

		String filename = listFile[i].getAbsolutePath();

    filename = "\""+filename+"\"";

		String justfilename = listFile[i++].getName();

		SesameObject newSesameNode = new SesameObject(filename);

		newSesameNode.setType(2);

        newSesameNode.setOutputFile(configGeneral.getHVOutDir()+"/"+justfilename+".out");

        if (filename.toUpperCase().indexOf("SAF") != -1)	// SAF file

        	{

            Sesame2.SAFFormatWaveform		wave;

            

            wave = new Sesame2.SAFFormatWaveform ();

            wave.loadHeader(filename);



            newSesameNode.setZname(wave.getCh0());

            newSesameNode.setNSname(wave.getCh1());

            newSesameNode.setEWname(wave.getCh2());

            newSesameNode.setStationname(wave.getStationName());

            newSesameNode.setWaveFormat(2);

            newSesameNode.setSamplingFreq(wave.getFreqSampleMax());

 //           System.out.println("viene");

 //           System.out.println(wave.getFreqSampleMax());

        	}

		else

        	{

            Sesame2.GSEFormatWaveform		wave;

            wave = new Sesame2.GSEFormatWaveform ();

            wave.loadHeader(filename);



            newSesameNode.setZname(wave.getNameChannel(0));

            newSesameNode.setNSname(wave.getNameChannel(1));

            newSesameNode.setEWname(wave.getNameChannel(2));

            newSesameNode.setStationname(wave.getNameStationChannel(0));

			newSesameNode.setWaveFormat(1);

            newSesameNode.setSamplingFreq(wave.getFreqSampleMax());

        	}



		DefaultMutableTreeNode SelectedNode = null;

		TreePath nodePath = myJTree.getSelectionPath();

		if(nodePath!=null && nodePath.getPathCount()>1) 

		  SelectedNode = (DefaultMutableTreeNode)nodePath.getLastPathComponent();

		if ( SelectedNode == null )  { // nothing selected

		  DefaultMutableTreeNode newNode = new DefaultMutableTreeNode(newSesameNode);

		  newNode.setAllowsChildren(false);

		  model.insertNodeInto(newNode, unasignedFile, unasignedFile.getChildCount());

		} else {

		 // go to other choice

		DefaultMutableTreeNode newNode = new DefaultMutableTreeNode(newSesameNode);

		newNode.setAllowsChildren(false);

		SesameObject obj = (SesameObject)SelectedNode.getUserObject();

		if (SelectedNode.getAllowsChildren()==false ) {

		 DefaultMutableTreeNode parent = (DefaultMutableTreeNode)SelectedNode.getParent();

		 if (parent != null) {

		    int selectedIndex = parent.getIndex(SelectedNode);

		    obj = (SesameObject)parent.getUserObject();

		    model.insertNodeInto(newNode, parent, selectedIndex + 1);

		 }

		} else {

		    model.insertNodeInto(newNode, SelectedNode, SelectedNode.getChildCount());

		}

		if (obj.getType()==0) {	

		     newSesameNode.setOutputFile(configGeneral.getHVOutDir()+"/"+obj.getName()+"/"+justfilename+".out");

		     newSesameNode.setType(1);

		     newNode.setUserObject(newSesameNode);

		     model.reload(newNode);

		    }

	    }

	  }

			 			 

	}

	

	 DefaultMutableTreeNode insertSite(String name,String output, String ProcessTime) {

        DefaultMutableTreeNode RootNode = (DefaultMutableTreeNode)myJTree.getModel().getRoot();

		SesameObject newSesameNode = new SesameObject(name);

		newSesameNode.setType(0);

		newSesameNode.setOutputFile(output);

		newSesameNode.setProcessTimeString(ProcessTime);

		DefaultMutableTreeNode newNode = new DefaultMutableTreeNode(newSesameNode);

		newNode.setAllowsChildren(true);

		int selectedIndex = RootNode.getChildCount();

		model.insertNodeInto(newNode, RootNode, selectedIndex);

		return newNode;

    }



	void JButtonInsertSite_actionPerformed(java.awt.event.ActionEvent event)

	{

				// Insert site into the project

		++indSite;

		JDialogSiteName dlg = new JDialogSiteName(new Frame(),true);

		dlg.JEditSiteName.setText("New_Site"+indSite);

		dlg.show();

		if( dlg.OK ) {		 

	     insertSite(dlg.JEditSiteName.getText(),configGeneral.getHVOutDir()+"/"+dlg.JEditSiteName.getText()+"/"+dlg.JEditSiteName.getText()+".out","_");	   			 

	    }

	}



	void JButtonRemove_actionPerformed(java.awt.event.ActionEvent event)

	{

	  // Remove node

		DefaultMutableTreeNode SelectedNode = null;

		TreePath nodePath = myJTree.getSelectionPath();

		if(nodePath!=null) {

		  SelectedNode = (DefaultMutableTreeNode)nodePath.getLastPathComponent();

		  if( SelectedNode.getLevel()==0 ) return;

		  if (SelectedNode == null ) return;

		   if (SelectedNode.getParent() != null ) { 

		     SesameObject obj = (SesameObject)SelectedNode.getUserObject();

		     if ( obj.getType()!=3) 

		     model.removeNodeFromParent(SelectedNode);		    

		   }

		}  

			 

	}

	

	void setDecimation (int dec)

    {

    Spectrum.setDecimation (dec);

    }



	void JButtonPlot_actionPerformed(java.awt.event.ActionEvent event)

	{

    this.previewPane.reset();

		PlotTraces(false);

			 

	}

	

	void resetProject(String label) {

	        root.removeAllChildren();

        	unasignedFile.removeAllChildren();

        	root.setUserObject(label);

            model.insertNodeInto(unasignedFile, root, 0);

        	model.reload(root);

        	ACTIVE_OBJECT_PLOTED = null;

        	PROJECT_NAME = null;

        	this.JEditLengthWin.setVisible(false);

        	this.JEditNumberWin.setVisible(false);

        	this.JEditOutFile.setVisible(false);

        	this.JEditSite.setVisible(false);

        	this.ProcessTimeLabel.setVisible(false);

	}

	

	void readGenConfig(StreamTokenizer streamTokenizer) {

	    	   String cad="";

	           String sval="";

	           int i=-1;

	         try {  

	           streamTokenizer.nextToken();

	           while ( (streamTokenizer.nextToken() != StreamTokenizer.TT_EOF)

	            && (streamTokenizer.sval.compareTo("</GENERAL_CONFIG>")!=0) ) {

	            i = streamTokenizer.sval.indexOf('=');

	            if( i != -1 ) {

	              cad = streamTokenizer.sval.substring(0,i);

	              sval = streamTokenizer.sval.substring(i+1);

	              if( cad.compareTo("WINSELECT_PROG")==0 )

	                configGeneral.setWinProg(sval);

	              if( cad.compareTo("WINPROG_PAR")==0 )

	                configGeneral.setWinProgPar(sval);  

	              if( cad.compareTo("WINPROG_OUT")==0 )

	                configGeneral.setWinProgOut(sval);

	              if( cad.compareTo("WINPROG_INP")==0 )

	                configGeneral.setWinProgInp(sval);

	              if( cad.compareTo("HV_RATIO_PROG")==0 )

	                configGeneral.setHVProg(sval);

	              if( cad.compareTo("HV_OUTDIR")==0 )

	                configGeneral.setHVOutDir(sval);

	              if( cad.compareTo("WARNING")==0 ){

                  if(sval.compareTo("true")==0)

	                configGeneral.setWarning(1);

                  else

                  configGeneral.setWarning(0);

                }

	              if( cad.compareTo("FIXWIND")==0 )

	                configGeneral.setFixWind((new Integer(sval)).intValue());

	              if( cad.compareTo("MINWIND")==0 )

	                configGeneral.setMinWind((new Integer(sval)).intValue());

	            }

	            while (streamTokenizer.nextToken() != StreamTokenizer.TT_EOL);

	          }

	          configGeneral.setInitValues();

		     } catch (Exception e)

			{

			System.out.println(e.getMessage());

			}



	}

	

	void readAutoWindowConfig(StreamTokenizer streamTokenizer) {

   			   String cad="";

	           String sval="";

	           int i=-1;	   

	         try {

	           streamTokenizer.nextToken();

	           while ( (streamTokenizer.nextToken() != StreamTokenizer.TT_EOF)

	             && (streamTokenizer.sval.compareTo("</AUTO_WINDOW_SELECTION>")!=0) ) {

	             i = streamTokenizer.sval.indexOf('=');

	             if( i != -1 ) {

	               cad = streamTokenizer.sval.substring(0,i);

	               sval = streamTokenizer.sval.substring(i+1);

	               if( cad.compareTo("STA")==0 )

	                 configAutoWin.setSTA((new Double(sval)).doubleValue());

	               if( cad.compareTo("LTA")==0 )

	                 configAutoWin.setLTA((new Double(sval)).doubleValue());  

	               if( cad.compareTo("MIN_THRESHOLD")==0 )

	                 configAutoWin.setMinThresold((new Double(sval)).doubleValue());

	               if( cad.compareTo("MAX_THRESHOLD")==0 )

	                 configAutoWin.setMaxThresold((new Double(sval)).doubleValue());

	               if( cad.compareTo("WIN_LENGTH")==0 )

	                 configAutoWin.setWindowLength((new Double(sval)).doubleValue());

	               if( cad.compareTo("WIN_LENGTH")==0 )

	                 configAutoWin.setWindowLength((new Double(sval)).doubleValue());

	               if( cad.compareTo("OVERLAP_PER")==0 )

	                 configAutoWin.setOverlapPercentage((new Double(sval)).doubleValue());

	               if( cad.compareTo("SATURATION")==0 )

	                 configAutoWin.setSaturation((new Integer(sval)).intValue());

	               if( cad.compareTo("TRANSIENT")==0 )

	                 configAutoWin.setTransient((new Integer(sval)).intValue());

	               if( cad.compareTo("BADPOINTS")==0 )

	                 configAutoWin.setToleranceLevel((new Double(sval)).doubleValue());

                  }

                 while (streamTokenizer.nextToken() != StreamTokenizer.TT_EOL);

	            }

	           configAutoWin.setInitValues();

             } catch (Exception e)

			{

			System.out.println(e.getMessage());

			}



	}

	

	void readManualWindowConfig(StreamTokenizer streamTokenizer) {

   			  String cad="";

	          String sval="";

	          int i=-1;	   

	        try {

	          streamTokenizer.nextToken();

	          while ( (streamTokenizer.nextToken() != StreamTokenizer.TT_EOF)

	             && (streamTokenizer.sval.compareTo("</MANUAL_WINDOW_SELECTION>")!=0) ) {

	          i = streamTokenizer.sval.indexOf('=');

	          if( i != -1 ) {

	           cad = streamTokenizer.sval.substring(0,i);

	           sval = streamTokenizer.sval.substring(i+1);

	           if( cad.compareTo("WIN_LENGTH")==0 )

	             configManualWin.setWindowLength((new Double(sval)).doubleValue());

	           if( cad.compareTo("TIME_SPACE")==0 )

	             configManualWin.setOverlap((new Double(sval)).doubleValue());

	          }

	          while (streamTokenizer.nextToken() != StreamTokenizer.TT_EOL);

	         }

	         configManualWin.setInitValues();

            } catch (Exception e)

			{

			System.out.println(e.getMessage());

			}



	}



void readFilterConfig(StreamTokenizer streamTokenizer) {

   			  String cad="";

	          String sval="";

	          int i=-1;	   

	        try {

	          streamTokenizer.nextToken();

	          while ( (streamTokenizer.nextToken() != StreamTokenizer.TT_EOF)

	             && (streamTokenizer.sval.compareTo("</FILTER_OPTIONS>")!=0) ) {

	          i = streamTokenizer.sval.indexOf('=');

	          if( i != -1 ) {

	           cad = streamTokenizer.sval.substring(0,i);

	           sval = streamTokenizer.sval.substring(i+1);

	           if( cad.compareTo("HIGH_PASS")==0 )

	             filterDialog.setHIGH((new Double(sval)).doubleValue());

	           if( cad.compareTo("LOW_PASS")==0 )

	             filterDialog.setLOW((new Double(sval)).doubleValue());

             if( cad.compareTo("BAND_PASS1")==0 )

	             filterDialog.setBAND1((new Double(sval)).doubleValue());

             if( cad.compareTo("BAND_PASS2")==0 )

	             filterDialog.setBAND2((new Double(sval)).doubleValue());

             if( cad.compareTo("ACTIVE_LOW")==0 )

	             filterDialog.setRadioLow((new Integer(sval)).intValue());

             if( cad.compareTo("ACTIVE_HIGH")==0 )

	             filterDialog.setRadioHigh((new Integer(sval)).intValue());

             if( cad.compareTo("ACTIVE_BAND")==0 )

	             filterDialog.setRadioBand((new Integer(sval)).intValue());

               

	          }

	          while (streamTokenizer.nextToken() != StreamTokenizer.TT_EOL);

	         }

	         filterDialog.setInitValues();

            } catch (Exception e)

			{

			System.out.println(e.getMessage());

			}



	}



  void readProcessingParameters(StreamTokenizer streamTokenizer) {

   			  String cad="";

	        String sval="";

	        int i=-1;	   



	        try 

          {

	          streamTokenizer.nextToken();

      

	          while ( (streamTokenizer.nextToken() != StreamTokenizer.TT_EOF) && 

                  (streamTokenizer.sval.compareTo("</PROCESSING_PARAMETERS>")!=0) ) 

              {

              i = streamTokenizer.sval.indexOf('=');



              if( i != -1 ) 

              {

              cad = streamTokenizer.sval.substring(0,i);

              sval = streamTokenizer.sval.substring(i+1);



              if (sval == null)

                sval = "";



              if( cad.compareTo("FREQ_SPACING")==0 )

                processingParameters.f_freqSpacing = sval;

              if( cad.compareTo("FREQ_SPACING_A1")==0 )

                processingParameters.f_arg1 = sval;

              if( cad.compareTo("FREQ_SPACING_A2")==0 )

                processingParameters.f_arg2 = sval;

              if( cad.compareTo("FREQ_SPACING_A3")==0 )

                processingParameters.f_arg3 = sval;

              if( cad.compareTo("OFFSET_REMOVAL")==0 )

                processingParameters.or_offsetRemoval = sval;

              if( cad.compareTo("OFFSET_REMOVAL_A1")==0 )

                processingParameters.or_arg1 = sval;

              if( cad.compareTo("TAPPERING")==0 )

                processingParameters.tp_tappering = sval;

              if( cad.compareTo("TAPPERING_A1")==0 )

                processingParameters.tp_arg1 = sval;

              if( cad.compareTo("INSTRUMENT_RESPONSE")==0 )

                processingParameters.instrumentResponse = sval;

              if( cad.compareTo("SMOOTHING")==0 )

                processingParameters.sm_smoothing = sval;

              if( cad.compareTo("SMOOTHING_A1")==0 )

                processingParameters.sm_arg1 = sval;

              if( cad.compareTo("SMOOTHING_A2")==0 )

                processingParameters.sm_arg2 = sval;

              if( cad.compareTo("MERGING")==0 )

                processingParameters.merging = sval;

              if( cad.compareTo("OUT_SINGLE_COMPONENT")==0 )

                processingParameters.outSingleComp = sval;

              if( cad.compareTo("AVERAGE")==0 )

                processingParameters.average = sval;

              if( cad.compareTo("OUT_SINGLE_WINDOWS")==0 )

                processingParameters.outSingleWindows = sval;

              }



            while (streamTokenizer.nextToken() != StreamTokenizer.TT_EOL); 

            }

          }

          catch (Exception e)

    			{

        	System.out.println(e.getMessage());

      		}



	}



	void readTree(StreamTokenizer streamTokenizer) {

	    	SesameObject obj;

	        indSite = 0;

            DefaultMutableTreeNode parent=null;

            int nwindow, windowlength;

	        String	inputfName,outputfName;

	        double w1,w2;

	        try {

	        streamTokenizer.nextToken();

	        while ( (streamTokenizer.nextToken() != StreamTokenizer.TT_EOF)

	          && (streamTokenizer.sval.compareTo("</TREE>")!=0) )

				{

				//System.out.println("token: "+streamTokenizer.sval);

				if (streamTokenizer.sval.equalsIgnoreCase("o")) { // unasigned file ignore				    

				    parent = unasignedFile;

				    while ((streamTokenizer.nextToken() != StreamTokenizer.TT_EOL)

				      && (streamTokenizer.sval.compareTo("</TREE>")!=0) );

				} else if (streamTokenizer.sval.equalsIgnoreCase("s")) { // site

              streamTokenizer.nextToken();

   				    //System.out.println(streamTokenizer.sval);

			   inputfName = streamTokenizer.sval;

         while(streamTokenizer.sval.lastIndexOf("\"")!=(streamTokenizer.sval.length()-1)){

                streamTokenizer.nextToken();

                inputfName = inputfName + " " + streamTokenizer.sval;

              }

           inputfName = inputfName.replace('\"',' ').trim();

           streamTokenizer.nextToken();

           

          /*   boolean enter = false;

              while(streamTokenizer.sval.indexOf("\"")<0){

                inputfName = inputfName + " " + streamTokenizer.sval;

                enter = true;

              }  if( enter) {

                inputfName = inputfName + " " + streamTokenizer.sval;      

                streamTokenizer.nextToken();

              }*/

               

                 outputfName = streamTokenizer.sval;  

                 while(streamTokenizer.sval.lastIndexOf("\"")!=(streamTokenizer.sval.length()-1)){

                streamTokenizer.nextToken();

                outputfName = outputfName + " " + streamTokenizer.sval;

              }

                 outputfName = outputfName.replace('\"',' ').trim();

                 streamTokenizer.nextToken();                    

               /* while(streamTokenizer.sval.indexOf("\"")<0){

                 outputfName = outputfName + " " + streamTokenizer.sval;

                streamTokenizer.nextToken();

              }*/

               

				    parent = insertSite(inputfName,outputfName,streamTokenizer.sval);

				    while( (streamTokenizer.nextToken() != StreamTokenizer.TT_EOL )

				    && (streamTokenizer.sval.compareTo("</TREE>")!=0) );                   

				} else { // data file

				 int type=1;

				 if (streamTokenizer.sval.equalsIgnoreCase("*")) type = 2;

 				 streamTokenizer.nextToken();

				   inputfName = streamTokenizer.sval;

              while(streamTokenizer.sval.lastIndexOf("\"")!=(streamTokenizer.sval.length()-1)){

                streamTokenizer.nextToken();

                inputfName = inputfName + " " + streamTokenizer.sval;

              }

        				 obj = new SesameObject(inputfName);          

                 streamTokenizer.nextToken();

                 outputfName = streamTokenizer.sval;  

              while(streamTokenizer.sval.lastIndexOf("\"")!=(streamTokenizer.sval.length()-1)){

                streamTokenizer.nextToken();

                outputfName = outputfName + " " + streamTokenizer.sval;

              }

                 outputfName = outputfName.replace('\"',' ').trim();

                 streamTokenizer.nextToken();

/*                 enter = false;

                while(streamTokenizer.sval.indexOf("\"")<0){

                 outputfName = outputfName + " " + streamTokenizer.sval;

                streamTokenizer.nextToken();

                enter = true;

              } if (enter) {

                  outputfName = outputfName + " " + streamTokenizer.sval;

                  streamTokenizer.nextToken();

              }*/



                 obj.setOutputFile(outputfName);

                 

                 obj.setWaveFormat((int)streamTokenizer.nval);

                 streamTokenizer.nextToken();

                 if(streamTokenizer.sval==null) {

                  String st=new Integer((int)(streamTokenizer.nval)).toString();

                  if(streamTokenizer.nval<100) 

                  {

                    streamTokenizer.nextToken();

                    st = st + streamTokenizer.sval;

                  }    

                 obj.setStationname(st);

                 } else  obj.setStationname(streamTokenizer.sval);

                 streamTokenizer.nextToken();

                 obj.setZname(streamTokenizer.sval);

                 streamTokenizer.nextToken();

                 obj.setNSname(streamTokenizer.sval);

                 streamTokenizer.nextToken();

                 obj.setEWname(streamTokenizer.sval);

                 streamTokenizer.nextToken();               

                 obj.setProcessTimeString(streamTokenizer.sval);

                 streamTokenizer.nextToken();               

                 obj.setSamplingFreq((double)streamTokenizer.nval);

                 streamTokenizer.nextToken();               

                 obj.setNumberWindows((int)streamTokenizer.nval);

                 streamTokenizer.nextToken();

                 obj.setWindowsLength(streamTokenizer.nval);

                 obj.setType(type);

                 //System.out.println(obj.getNumberWindows());

                 //System.out.println(obj.getWindowsLength());

                 int i = 0;

                 w1 = -1;

                 w2 = -1;

                 int n = obj.getNumberWindows();

                 int k = 0;

                 while( streamTokenizer.nextToken() != StreamTokenizer.TT_EOL ) {                  

                  if( k ==0 ) w1 = streamTokenizer.nval;

                  else w2 = streamTokenizer.nval;

                  ++k;

                  if( k==2 ) k=0;

                  if( (i < n) && (k==0) ) {

                    obj.addSesameWindow(w1,w2);

                    ++i;

                    streamTokenizer.nextToken();

                    if(streamTokenizer.sval.compareTo("M")==0)

                     obj.setLastAutoWindow(false);

                   }

                 }

                 if (parent != null) {

                   DefaultMutableTreeNode newNode = new DefaultMutableTreeNode(obj);

                   newNode.setAllowsChildren(false);

		           model.insertNodeInto(newNode, parent, parent.getChildCount());       

		         }

                }

              }

            } catch (Exception e)

			{

			System.out.println(e.getMessage());

			}

	}



	void OpenGeneralConfigFile()

  {

    this.configGeneral.OpenFile();

  }

  

	void OpenSesameProject(String filename) {

	    try

        	{

        	FileReader reader = new FileReader(filename);

            resetProject(filename);

        	StreamTokenizer streamTokenizer;



			streamTokenizer = new StreamTokenizer(reader);



			streamTokenizer.parseNumbers();

			streamTokenizer.wordChars(33, 255);

			streamTokenizer.whitespaceChars(1, 32);

			streamTokenizer.eolIsSignificant(true);

			while ( streamTokenizer.nextToken() != StreamTokenizer.TT_EOF) {

			 System.out.println(streamTokenizer.sval);

			 if( streamTokenizer.sval.compareTo("<TREE>")==0 ) {

               readTree(streamTokenizer);

			 }

			 if( streamTokenizer.sval.compareTo("<GENERAL_CONFIG>")==0 ) {

			   readGenConfig(streamTokenizer);

			 }

			 if( streamTokenizer.sval.compareTo("<AUTO_WINDOW_SELECTION>")==0 ) {

			   readAutoWindowConfig(streamTokenizer);

			  }

			 if( streamTokenizer.sval.compareTo("<MANUAL_WINDOW_SELECTION>")==0 ) {

			  readManualWindowConfig(streamTokenizer);

			 }

       if( streamTokenizer.sval.compareTo("<PROCESSING_PARAMETERS>")==0 ) {

			  readProcessingParameters(streamTokenizer);

			 }

       if( streamTokenizer.sval.compareTo("<FILTER_OPTIONS>")==0 ) {

			  readFilterConfig(streamTokenizer);

			 }

       int nt = streamTokenizer.nextToken();

			while ((nt != StreamTokenizer.TT_EOL) && (nt != StreamTokenizer.TT_EOF))

      {

        nt = streamTokenizer.nextToken();

      }

			}			

	        }

        catch (Exception e)

			{

			System.out.println(e.getMessage());

			}

	}

	

	void SaveSesameProject(String filename) {

	    // Save the project

	    int numbersite = root.getChildCount();

	    int i,j,k;

	    DefaultMutableTreeNode nodesite;

	    DefaultMutableTreeNode nodefile;

	    SesameObject obj;

	    String strout="";

	    System.out.println("Saving "+filename);

	    try {

	    PrintWriter f = new PrintWriter(new BufferedWriter(new FileWriter(filename)));

	    root.setUserObject(filename);

	    model.reload(root);

	    f.println("<TREE>");

	    for( i=0; i<numbersite; ++i) {

	       nodesite = (DefaultMutableTreeNode)root.getChildAt(i);

	       obj = (SesameObject)nodesite.getUserObject();

	       if (obj.getType()==3) f.println("o " + obj.getName());

	       if (obj.getType()==0) f.println("s " + "\""+obj.getName()+"\"" + "  \""+obj.getOutputFile()+"\""+"  "+ obj.getProcessTime());

	       int numberdatafile = nodesite.getChildCount();

	       for(j=0; j<numberdatafile; ++j) {

	         nodefile = (DefaultMutableTreeNode)nodesite.getChildAt(j);

	         obj = (SesameObject)nodefile.getUserObject();

	         if (obj.getType()==1) strout = "    d ";

	         if (obj.getType()==2) strout = "    * ";

	         strout = strout +obj.getName()+"    \""+obj.getOutputFile()+"\""+ "  "+ obj.getWaveFormat()+"  "+obj.getStationName()+

	         "  "+ obj.getZname()+ "  "+obj.getNSname()+"  "+obj.getEWname() +"  "+ obj.getProcessTime()+"  "+obj.getSamplingFreq()+"  "+obj.getNumberWindows()+

	         "  "+obj.getWindowsLength();

	         for( k=1; k<=obj.getNumberWindows(); ++k) {

	            strout = strout + "  " + obj.getSesameWindowFirstIndex(k)+ "  " + 

	            obj.getSesameWindowSecondIndex(k)+ " " + obj.getSesameWindowAutoFlag(k); 

	         }

	         f.println(strout);

	       }	       

	    }

	    f.println("</TREE>");

	    f.println("<GENERAL_CONFIG>");

	    f.println("WINSELECT_PROG="+configGeneral.getWinProg());

	    f.println("HV_RATIO_PROG="+configGeneral.getHVProg());

	    f.println("WINPROG_PAR="+configGeneral.getWinProgPar());

	    f.println("HVPROG_PAR="+configGeneral.getHVProgPar());

	    f.println("WINPROG_OUT="+configGeneral.getWinProgOut());

	    f.println("WINPROG_INP="+configGeneral.getWinProgInp());

	    f.println("HV_OUTDIR="+configGeneral.getHVOutDir());

	    f.println("WARNING="+ configGeneral.isWarning());

	    f.println("FIXWIND="+ configGeneral.isFixWind());

	    f.println("MINWIND="+ configGeneral.getMinWind());

	    f.println("</GENERAL_CONFIG>");    

	    f.println("<AUTO_WINDOW_SELECTION>");  

	    f.println("STA="+ configAutoWin.getSTA());

	    f.println("LTA="+ configAutoWin.getLTA());

	    f.println("MIN_THRESHOLD="+ configAutoWin.getMinThresold());

	    f.println("MAX_THRESHOLD="+ configAutoWin.getMaxThresold());

	    f.println("WIN_LENGTH="+ configAutoWin.getWindowLength());

	    f.println("OVERLAP_PER="+ configAutoWin.getOverlapPercentage());

	    f.println("SATURATION="+ configAutoWin.isSaturation());

	    f.println("TRANSIENT="+ configAutoWin.isTransient());

      f.println("BADPOINTS="+ configAutoWin.getToleranceLevel());

	    f.println("</AUTO_WINDOW_SELECTION>");  

	    f.println("<MANUAL_WINDOW_SELECTION>");

	    f.println("WIN_LENGTH="+ configManualWin.getWindowLength());

	    f.println("TIME_SPACE="+ configManualWin.getOverlap());

	    f.println("</MANUAL_WINDOW_SELECTION>");

      f.println("<PROCESSING_PARAMETERS>");

      f.println("FREQ_SPACING="+ processingParameters.f_freqSpacing);

      f.println("FREQ_SPACING_A1="+ processingParameters.f_arg1);

      f.println("FREQ_SPACING_A2="+ processingParameters.f_arg2);

      f.println("FREQ_SPACING_A3="+ processingParameters.f_arg3);

      f.println("OFFSET_REMOVAL="+ processingParameters.or_offsetRemoval);

      f.println("OFFSET_REMOVAL_A1="+ processingParameters.or_arg1);

      f.println("TAPPERING="+ processingParameters.tp_tappering);

      f.println("TAPPERING_A1="+ processingParameters.tp_arg1);

      f.println("INSTRUMENT_RESPONSE=" + processingParameters.instrumentResponse);

      f.println("SMOOTHING=" + processingParameters.sm_smoothing);

      f.println("SMOOTHING_A1=" + processingParameters.sm_arg1);

      f.println("SMOOTHING_A2=" + processingParameters.sm_arg2);

      f.println("MERGING=" + processingParameters.merging);

      f.println("OUT_SINGLE_COMPONENT=" + processingParameters.outSingleComp);

      f.println("AVERAGE=" + processingParameters.average);

      f.println("OUT_SINGLE_WINDOWS=" + processingParameters.outSingleWindows);

      f.println("</PROCESSING_PARAMETERS>");

      f.println("<FILTER_OPTIONS>");

	    f.println("HIGH_PASS="+ filterDialog.getHIGH());

	    f.println("LOW_PASS="+ filterDialog.getLOW());

	    f.println("BAND_PASS1="+ filterDialog.getBAND1());

	    f.println("BAND_PASS2="+ filterDialog.getBAND2());

	    f.println("ACTIVE_LOW="+ filterDialog.getRadioLow());

	    f.println("ACTIVE_HIGH="+ filterDialog.getRadioHigh());

	    f.println("ACTIVE_BAND="+ filterDialog.getRadioBand());

	    f.println("</FILTER_OPTIONS>");

	    f.close();

	    }catch (IOException Ex)

        {

           System.out.println(Ex.getMessage());

         

        }

	}





	void saveAsItem_actionPerformed(java.awt.event.ActionEvent event)

	{

		// Save project as

		fileChooser.setMultiSelectionEnabled(false);

		fileChooser.showSaveDialog(this);

		File file;

		if( (file=fileChooser.getSelectedFile())!=null ) {

		 SaveSesameProject(file.getAbsolutePath());

		 PROJECT_NAME = file.getAbsolutePath();

		}

	}

	



	class SymKey extends java.awt.event.KeyAdapter

	{



		public void keyTyped(java.awt.event.KeyEvent event)

		{

			Object object = event.getSource();

			if (object == JEditSite)

				JEditSite_keyTyped(event);

			else if (object == JEditOutFile)

				JEditOutFile_keyTyped(event);

			

		}

	}



	void JEditSite_keyTyped(java.awt.event.KeyEvent event)

	{		

		// modify site

	    DefaultMutableTreeNode[] nodes = getSelectedObject();

		if( nodes!=null ) {

		    SesameObject obj = (SesameObject)nodes[0].getUserObject();

		    if( event.getKeyChar() == event.VK_ENTER ) {

		     obj.setName(JEditSite.getText());

		     nodes[0].setUserObject(obj);

		     model.reload(nodes[0]);

		    }

		} 

	}

	

	DefaultMutableTreeNode[] getSelectedObject() {

	    int i;

	    TreePath[] nodePath = myJTree.getSelectionPaths();

	    DefaultMutableTreeNode[] SelectedNodes = new DefaultMutableTreeNode[50];

		if(nodePath!=null ) {

		  int n = nodePath.length;

		  if( n > 49 ) n = 49;

		  for(i = 0; i< n; ++i) 

		   SelectedNodes[i] = (DefaultMutableTreeNode)nodePath[i].getLastPathComponent();

		  SelectedNodes[i]=null; // last one 

		  return(SelectedNodes);

		}

		return null;

	}





	class SymFocus extends java.awt.event.FocusAdapter

	{

		public void focusLost(java.awt.event.FocusEvent event)

		{

			Object object = event.getSource();

			if (object == JEditSite)

				JEditSite_focusLost(event);

			else if (object == JEditOutFile)

				JEditOutFile_focusLost(event);

		}

	}



	void JEditSite_focusLost(java.awt.event.FocusEvent event)

	{

			// modify site

	/*	DefaultMutableTreeNode[] nodes = getSelectedObject();

		if( nodes!=null) {

		    SesameObject obj = (SesameObject)nodes[0].getUserObject();

		    obj.setName(JEditSite.getText());

		    nodes[0].setUserObject(obj);

		    model.reload(nodes[0]);

		}*/ 

	}



	void JEditOutFile_keyTyped(java.awt.event.KeyEvent event)

	{

		// modify output file

	    DefaultMutableTreeNode[] nodes = getSelectedObject();

		if( nodes!=null ) {

		    SesameObject obj = (SesameObject)nodes[0].getUserObject();

		    if( event.getKeyChar() == event.VK_ENTER ) {

		     obj.setOutputFile(JEditOutFile.getText());

		     nodes[0].setUserObject(obj);

		     model.reload(nodes[0]);

		    }

		} 



	}



	class SymItem implements java.awt.event.ItemListener

	{

		public void itemStateChanged(java.awt.event.ItemEvent event)

		{

			Object object = event.getSource();

			if (object == JCheckBoxWindowSel)

				JCheckBoxWindowSel_itemStateChanged(event);

		}

	}



	void JCheckBoxWindowSel_itemStateChanged(java.awt.event.ItemEvent event)

	{

		// enable/disable window selection

		previewPane.EnableWindowSelection(JCheckBoxWindowSel.isSelected());

			 

	}

	

	public void setWindowsAll(Windows winds) {

	    DefaultMutableTreeNode[] nodes = getSelectedObject();

		if( nodes!=null ) {

		    int i=0;

		    while( nodes[i]!=null ) {

	          setWindows(winds,nodes[i],false);	 

	          ++i;

	        }

		}

	}

	

	public void setWindows(Windows winds,DefaultMutableTreeNode node,boolean filter_out) {

		if( node!=null ) {

		    SesameObject obj = (SesameObject)node.getUserObject();

		    obj.setSesameWindows(winds);

		    if( filter_out ) obj.setSesameWindowsFilter(winds);

		    if( this.JCheckBoxWindowSel.isSelected())

		     obj.setWindowsLength(configManualWin.getWindowLength());

		    else

		     obj.setWindowsLength(configAutoWin.getWindowLength());

		    node.setUserObject(obj);

		    model.reload(node);

		    JEditNumberWin.setText(""+obj.getNumberWindows());
		    JEditLengthWin.setText(""+obj.getWindowsLength());
		}

	}

	



	void newItem_actionPerformed(java.awt.event.ActionEvent event)

	{

		resetProject("New_Project");

		previewPane.reset();

	}



	void newButton_actionPerformed(java.awt.event.ActionEvent event)

	{

		resetProject("New_Project");

		previewPane.reset();

	}



	void manualWindowItem_actionPerformed(java.awt.event.ActionEvent event)

	{

		// show manual window dialog for configuration

		configManualWin.show();

		if(ACTIVE_OBJECT_PLOTED!=null) {

		    previewPane.setWindowLength(configManualWin.getWindowLength());

		    previewPane.setSpaceBetweenWindows(configManualWin.getOverlap());

		}

	}

	

	

	void createFileListSelectedSite(DefaultMutableTreeNode site,boolean filter_out) {

	   try {

	    PrintWriter f = new PrintWriter(new BufferedWriter(new FileWriter(configGeneral.getWinProgInp())));

	    int n = site.getChildCount();

	    int i=0;

	    for(i=0; i<n; ++i) {

	        DefaultMutableTreeNode nodefile = (DefaultMutableTreeNode)site.getChildAt(i);

	        SesameObject obj = (SesameObject)nodefile.getUserObject();

	        if (filter_out) {

	         ProcessDataFilter(nodefile,false);

	         f.println(obj.getOutputFile()+"_SAF_fi");

	        }

	        else {

           String filename = obj.getName().replace('\"',' ');

	         f.println(filename.trim());

          }

	    }

        f.close();

	    }catch (IOException Ex)

        {

           System.out.println(Ex.getMessage());

         

        }

	}



  void saveHVParameters(String fileName,boolean filter_out) {

	   try 

     {

	    PrintWriter f = new PrintWriter(new BufferedWriter(new FileWriter(fileName)));



      f.println ("### section processing");



	    f.print("freq_spacing:" + processingParameters.f_freqSpacing);

      if (processingParameters.f_freqSpacing.equals("fft_red")) 

        f.println (":" + processingParameters.f_arg1 + ":" + processingParameters.f_arg2);

      if (processingParameters.f_freqSpacing.equals("linear") || processingParameters.f_freqSpacing.equals("log")) 

        f.println (":" + processingParameters.f_arg1 + ":" + processingParameters.f_arg2 + ":" + processingParameters.f_arg3);

      if (processingParameters.f_freqSpacing.equals("fft")) 

        f.println("");

      if( filter_out ) {

         f.println("offset_rem:" + getSelectedFilter());

         f.println("filter_out:yes");

      } else {

      f.print("offset_rem:" + processingParameters.or_offsetRemoval);

      if (processingParameters.or_offsetRemoval.equals("high-pass")) 

        f.println (":" + processingParameters.or_arg1);

      else

        f.println("");

      }

      f.print("taper:" + processingParameters.tp_tappering);

      if (processingParameters.tp_tappering.equals("cos")) 

        f.println (":" + processingParameters.tp_arg1);

      else

        f.println("");



//      f.println("instrument_resp:" + processingParameters.instrumentResponse);



      f.print("smooth:" + processingParameters.sm_smoothing);

      if (processingParameters.sm_smoothing.equals("none")) 

        f.println ("");

      if (processingParameters.sm_smoothing.equals("linear") || processingParameters.sm_smoothing.equals("log")) 

        f.println (":" + processingParameters.sm_arg1 + ":" + processingParameters.sm_arg2);

      if (processingParameters.sm_smoothing.equals("konno-ohmachi")) 

        f.println (":" + processingParameters.sm_arg1);



      f.println("merge_type:" + processingParameters.merging);



//      f.println("single_component:" + processingParameters.outSingleComp);



//      f.println("average_type:" + processingParameters.average);



      f.println("single_win_out:" + processingParameters.outSingleWindows);



      f.println("### end processing");



	    f.close();

	   }

     catch (IOException Ex)

     {

     System.out.println(Ex.getMessage());

     }

	}

	

	void createFileListSelectedDataFile(DefaultMutableTreeNode nodefile,boolean filter_out) {

	    if( filter_out) ProcessDataFilter(nodefile,false);

	   try {

	    PrintWriter f = new PrintWriter(new BufferedWriter(new FileWriter(configGeneral.getWinProgInp())));

	    SesameObject obj = (SesameObject)nodefile.getUserObject();

	    if( filter_out )

	     f.println(obj.getOutputFile()+"_SAF_fi");

	    else {

       String filename = obj.getName().replace('\"',' ');

	     f.println(filename.trim());

      }

        f.close();

	    }catch (IOException Ex)

        {

           System.out.println(Ex.getMessage());

         

        }

	}

	

	void createWindowParametersFile() {

	    try {

	    PrintWriter f = new PrintWriter(new BufferedWriter(new FileWriter(configGeneral.getWinProgPar())));

	    f.println(configAutoWin.getSTA()+ " " + configAutoWin.getLTA()+ " " + configAutoWin.getMinThresold()+

	              " " + configAutoWin.getMaxThresold()+" "+ configAutoWin.getWindowLength()+ " " + configAutoWin.getOverlapPercentage()/100

	              +" "+ configAutoWin.isSaturation()+" "+configAutoWin.isTransient()+ " "+ configAutoWin.getToleranceLevel());

        f.close();

	    }catch (IOException Ex)

        {

           System.out.println(Ex.getMessage());

         

        }

	}

	

	void setAutomaticWindowSelection(DefaultMutableTreeNode nodefile,boolean filter_out) {

	    WindowFileReader wrdr;

        Windows ws = new Windows();

        Spectrum s1 = new Spectrum();

        

	    SesameObject obj = (SesameObject)nodefile.getUserObject();

      s1.setSamplingRate(obj.getSamplingFreq());

	    s1.setWindows(ws);

	    if(filter_out)

	     wrdr= new WindowFileReader(configGeneral.getWinProgOut(), "\"" + obj.getOutputFile()+"_SAF_fi\"" ,s1);    

	    else

	     wrdr= new WindowFileReader(configGeneral.getWinProgOut(),obj.getName(),s1);    

	    wrdr.read();

	    setWindows(s1.getWindows(),nodefile,filter_out);

	    //setComponentsName(wrdr.getZname(),wrdr.getNSname(),wrdr.getEWname(),wrdr.getStationname(),nodefile);

	    if(ACTIVE_OBJECT_PLOTED!=null) {

	        previewPane.setWindows(obj.getSesameWindows());

	        previewPane.plot();

	    }

	}

	

	void WindowSelectionforSelectedSite(DefaultMutableTreeNode site,boolean filter_out) {

	    createFileListSelectedSite(site,filter_out);	    
	        try {
      FileWriter outFile = new FileWriter(configGeneral.getWinProgOut());
      outFile.close();
	    }catch (IOException Ex)
        {
           System.out.println(Ex.getMessage());

        }

      runcommand(configGeneral.getWinProg(),"\""+configGeneral.getWinProgInp()+"\"  \"" + configGeneral.getWinProgPar() + "\"  \""+ configGeneral.getWinProgOut()+"\"");
      //runcommand(configGeneral.getWinProg(),configGeneral.getWinProgInp()+" " + configGeneral.getWinProgPar() + " "+ configGeneral.getWinProgOut());

	    int n = site.getChildCount();

	    int i=0;

	    for(i=0; i<n; ++i) {

	      DefaultMutableTreeNode nodefile = (DefaultMutableTreeNode)site.getChildAt(i);

	      setAutomaticWindowSelection(nodefile,filter_out);

	    }

	}

	

	void processingforSelectedSite(DefaultMutableTreeNode site,boolean onlywindow,boolean filter_out) {

	    if( onlywindow ) {

	        WindowSelectionforSelectedSite(site,filter_out);

	        return;

	    }

	    ProcessData(site,false);

	}

	

	void WindowSelectionforSelectedDataFile(DefaultMutableTreeNode nodefile,boolean filter_out) {

	    createFileListSelectedDataFile(nodefile,filter_out);
      try {
      FileWriter outFile = new FileWriter(configGeneral.getWinProgOut());
      outFile.close();
	    }catch (IOException Ex)
        {
           System.out.println(Ex.getMessage());

        }
	    runcommand(configGeneral.getWinProg(),"\""+configGeneral.getWinProgInp()+"\"  \"" + configGeneral.getWinProgPar() + "\"  \""+ configGeneral.getWinProgOut()+"\"");

	    setAutomaticWindowSelection(nodefile,filter_out);

	}

	

	void processingforSelectedDataFile(DefaultMutableTreeNode datafile,boolean onlywindow,boolean filter_out) {

	    if( onlywindow ) {

	        WindowSelectionforSelectedDataFile(datafile,filter_out);

	        return;

	    }

	    ProcessData(datafile,true);

	}

	

	void viewOutputForDataFile(DefaultMutableTreeNode datafile)

    	{

	    SesameObject obj = (SesameObject) datafile.getUserObject();



      GuiWindow1.displayFile (obj.getName() , obj.getOutputFile() , obj.getSesameWindows() , processingParameters);

      }

	

	boolean createWindowSelectionDataFile(DefaultMutableTreeNode nodefile) {

	    SesameObject obj = (SesameObject)nodefile.getUserObject();

	    int k = obj.getNumberWindows();

	    if ( k <= 0 ) 

	        return false;

	    if ( obj.mixWindows() ) MIXWINDOWS = true;

	    try {

	    PrintWriter f = new PrintWriter(new BufferedWriter(new FileWriter(configGeneral.getWinProgOut())));

	    int i=0;

	    for(i=1; i<=k; ++i) {

	        f.print(obj.getName()+"  "+(double)(obj.getSesameWindowFirstIndex(i))+ "  "+

	             (double)(obj.getSesameWindowSecondIndex(i)) + " " + obj.getWaveFormat());



            if (obj.getWaveFormat()== 1)

                f.println(" " + obj.getZname()+" "+ obj.getNSname()+" "+obj.getEWname()+" "+obj.getStationName());

            else

                f.println("");

	    }

        f.close();

	    }catch (IOException Ex)

        {

           System.out.println(Ex.getMessage());

         

        }

        return true;

	}

	

	boolean createWindowSelectionSite(DefaultMutableTreeNode site) {

	   boolean out = false;

	   try {

	    PrintWriter f = new PrintWriter(new BufferedWriter(new FileWriter(configGeneral.getWinProgOut())));

	    int n = site.getChildCount();

	    int i=0,j;

	    for(i=0; i<n; ++i) {

	        DefaultMutableTreeNode nodefile = (DefaultMutableTreeNode)site.getChildAt(i);

	        SesameObject obj = (SesameObject)nodefile.getUserObject();

	        int k = obj.getNumberWindows();

	        if( k>0 ) {

	            out=true;

	            if ((configGeneral.isFixWind()==1) && (k>=configGeneral.getMinWind()))

	             k=configGeneral.getMinWind();

	            else if( configGeneral.isFixWind()==1) {

	             k = 0;

	             NOWINDOWS = true;

	            }

	        } else NOWINDOWS = true;

	        if ( obj.mixWindows() ) MIXWINDOWS = true;

	        for(j=1; j<=k; ++j)

	            {

                f.print(obj.getName()+"  "+(int)(obj.getSesameWindowFirstIndex(j))+ "  "+

	             (int)(obj.getSesameWindowSecondIndex(j)) + " " + obj.getWaveFormat());



				if (obj.getWaveFormat()== 1)

					f.println(" " + obj.getZname()+" "+ obj.getNSname()+" "+obj.getEWname()+" "+obj.getStationName());

				else

					f.println("");

    	        }

	    }

        f.close();

	    }catch (IOException Ex)

        {

           System.out.println(Ex.getMessage());

         

        }

        return out;

	}

	

	void ProcessData(DefaultMutableTreeNode nodefile,boolean singlefile) {

	    if( singlefile) {

	      if( !createWindowSelectionDataFile(nodefile) ) return;

	    }

	    else

	      if( !createWindowSelectionSite(nodefile) ) return;	    

	    SesameObject obj = (SesameObject)nodefile.getUserObject();

	    String cad=obj.getOutputFile();

	    cad = cad.replace('/', '\\');

	    int i = cad.indexOf("\\");

	    String dir="";

	    while(i!=-1) {

         dir = dir + cad.substring(0,i);

         File td = new File(dir);

         td.mkdir();

         cad = cad.substring(i+1);

         i = cad.indexOf("\\");

         dir = dir + "/";

        } 



      saveHVParameters (configGeneral.getHVProgPar(),false);

	    int out = runcommand(configGeneral.getHVProg()," \""+configGeneral.getWinProgOut()+"\" \""+

	      configGeneral.getHVProgPar()+"\" \""+obj.getOutputFile()+"\"");

	    if( (out==0) || (out==1) ) obj.setProcessTime(Calendar.getInstance()); 

	    nodefile.setUserObject(obj);

		    model.reload(nodefile);

		ProcessTimeLabel.setText(obj.getProcessTime());

	}

	

	

	void processingUnasignedFiles(DefaultMutableTreeNode unsigned,boolean onlywindow,boolean filter_out) {

	    int n = unsigned.getChildCount();

	    int i=0;

	    for(i=0; i<n; ++i) {

	      DefaultMutableTreeNode nodefile = (DefaultMutableTreeNode)unsigned.getChildAt(i);

	      if( onlywindow )

	       WindowSelectionforSelectedDataFile(nodefile,filter_out);

	      else

	       ProcessData(nodefile,true);

	    }

	}

	

	

	void processingSelectedNodes(boolean onlywindow,boolean filter_out,boolean showwarning,boolean continueforRest) {

	    // onlywindow : just automatic window selection

	    consol.textArea1.setText("");

		WARNING = false;

		MIXWINDOWS = false;

		NOWINDOWS = false;

	    DefaultMutableTreeNode[] nodes = getSelectedObject();

		if( (nodes!=null) && (nodes[0].getLevel()!=0)) {

		  int i=0;

		  this.createWindowParametersFile();

		  while(nodes[i]!=null) {

		    SesameObject obj = (SesameObject)nodes[i].getUserObject();

		    if( obj.getType()==0 ) processingforSelectedSite(nodes[i],onlywindow,filter_out);

		    if( (obj.getType()==1) || (obj.getType()==2) ) processingforSelectedDataFile(nodes[i],onlywindow,filter_out);

		    if( obj.getType()==3 ) processingUnasignedFiles(nodes[i],onlywindow,filter_out);

		    ++i;

		    if (continueforRest==false) {

		        setWindowsAll(obj.getSesameWindows());

		        break;

		    }

		  }

		} else {

		    Object[] options = { "Close" }; 

              int answer = JOptionPane.showOptionDialog(null, "Nothing Selected", 

                 "Warning", JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE, null, options, options[0]);       

           return;

		}

		if( showwarning ) {

		 if ( WARNING && this.configGeneral.isWarning()) {

		    Object[] options = { "YES", "NO" }; 

              int answer = JOptionPane.showOptionDialog(null, "Error or Warning has been occured. Do you want to see details ?", 

                 "Warning", JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE, null, options, options[0]);       

             if ( answer == 0 ) consol.show();

          } else {

            Object[] options = { "Close" }; 

              int answer = JOptionPane.showOptionDialog(null, "Successfull Process", 

                 "Successfull", JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE, null, options, options[0]);       

          }

        if(configGeneral.isWarning()) {

	      if( MIXWINDOWS ) {

	        Object[] options = { "Close" }; 

              int answer = JOptionPane.showOptionDialog(null, "Automatic and Manual Windows were processed", 

                 "Warning", JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE, null, options, options[0]);

	      }

	      if( NOWINDOWS ) {

	        Object[] options = { "Close" }; 

              int answer = JOptionPane.showOptionDialog(null, "One or more files does not contain any windows selected",

                 "Warning", JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE, null, options, options[0]);

	      }

	    }

	   }

	}

	

	int runcommand(String cmdseis, String par) {

	    // Execute an external command

	    // cmdsei  : command

	    // par :  parameters

	    int i;

	    int out = -1;

	    String[] env = new String[1];

	    env[0] = new String("SESAME_VERSION=1.0");

	    String cad = cmdseis + " " + par;

	    String s;

	    String  OPS = System.getProperty( "os.name" );

        //System.out.println("Operating System: "+ OPS);

        if( OPS.indexOf("Wind")!=-1 ) {

          cad = cad.replace('/','\\');                    

        }  

        System.out.println(cad);

        this.setCursor(Cursor.WAIT_CURSOR);

	    try {

	     Process myProcess = Runtime.getRuntime().exec( cad, env);

	     //DataInputStream in = new DataInputStream(myProcess.getInputStream());

	     BufferedReader in = new  BufferedReader(new InputStreamReader(myProcess.getInputStream())); 

          while ((s = in.readLine()) != null) {

             System.out.println(s);    

             consol.textArea1.append(s+"\n");

          }

          out = myProcess.exitValue();

          if ( out !=0 ) WARNING=true;

          myProcess.destroy();

	    }    

	    catch (Exception Ex)

        {

           System.out.println(Ex.getMessage());

           Ex.printStackTrace() ;



        }

        System.out.println("Done. Exit="+out);

        this.setCursor(Cursor.DEFAULT_CURSOR);

        return out;

	    

	}    



	void winNoFilterItem_actionPerformed(java.awt.event.ActionEvent event)

	{

		// automatic window selection

		this.processingSelectedNodes(true,false,true,true);

		 		

			 

	}



	void automaticWindowItem_actionPerformed(java.awt.event.ActionEvent event)

	{

		// auto window selection configuration.

		this.configAutoWin.show();

		this.createWindowParametersFile();

	}



	void generalItem_actionPerformed(java.awt.event.ActionEvent event)

	{

		// general configuration

		this.configGeneral.show();	 

	}



  void processingItem_actionPerformed(java.awt.event.ActionEvent event)

	{

		// general configuration

  ParametersDlg processingParametersDlg = new ParametersDlg (processingParameters);

	processingParametersDlg.show();	 

	}



	void spectralRatioMenuItem_actionPerformed(java.awt.event.ActionEvent event)

	{

		// process H/V ratio

        processingSelectedNodes(false,false,true,true);			         

	}



	class SymComponent extends java.awt.event.ComponentAdapter

	{

		public void componentResized(java.awt.event.ComponentEvent event)

		{

			Object object = event.getSource();

			if (object == JFrameSesame.this)

				JFrameSesame_componentResized(event);

		}

	}



	void JFrameSesame_componentResized(java.awt.event.ComponentEvent event)

	{

		// Resize

    

    previewPane.setSize(this.getSize().width - XDIF1,this.getSize().height-YDIF1);

    

    //JScrollPane1.setSize(this.getSize().width-XDIF1, this.getSize().height-YDIF1);

	/*	if( FIRSTSHOW ) {

		    FIRSTSHOW = false;

		    XDIF1 = this.getSize().width - JScrollPane1.getSize().width;

		    YDIF1 = this.getSize().height - JScrollPane1.getSize().height;

		} else {

		 JScrollPane1.setSize(this.getSize().width-XDIF1, this.getSize().height-YDIF1);

		 previewPane.setBounds(0,0,1100,450);

		}*/

	}



	void JButtonViewOutput_actionPerformed(java.awt.event.ActionEvent event)

	{

		// View spectrum output

		DefaultMutableTreeNode[] nodes = getSelectedObject();



		if( nodes!=null )

      {

      if (nodes[0]!=null)

        {

        SesameObject obj = (SesameObject)nodes[0].getUserObject();

        if( (obj.getType()==1) || (obj.getType()==2) || (obj.getType()==0) )

          viewOutputForDataFile(nodes[0]);

        }

      }

	}



	void filterItem_actionPerformed(java.awt.event.ActionEvent event)

	{

		// dialog box for filter options

        this.filterDialog.show();			 

	}

	

	void ProcessDataFilter(DefaultMutableTreeNode nodefile,boolean showtrace) {

	   SesameObject obj = (SesameObject)nodefile.getUserObject();

	   if( (obj.getType()==1) || (obj.getType()==2) ) { //data file

	    String winfile = configGeneral.getHVOutDir()+"/filtertempsesame0.txt";

	    createInputFileforFilter(obj,winfile);

	    String cad=obj.getOutputFile();

	    cad = cad.replace('/', '\\');

	    int i = cad.indexOf("\\");

	    String dir="";

	    while(i!=-1) {

         dir = dir + cad.substring(0,i);

         File td = new File(dir);

         td.mkdir();

         cad = cad.substring(i+1);

         i = cad.indexOf("\\");

         dir = dir + "/";

        } 

       saveHVParameters (configGeneral.getHVProgPar(),true);

	    int out = runcommand(configGeneral.getHVProg(),"\""+winfile+"\"  \""+

	      configGeneral.getHVProgPar()+"\"  \""+obj.getOutputFile()+"\""); 

        if(showtrace && ACTIVE_OBJECT_PLOTED==null) PlotTraces(false);

	    if(showtrace)

	      PlotTraces(true);

	   }

	}

	

	String getSelectedFilter() {

	    if ( filterDialog.JRadioButtonHigh.isSelected() )

	      return "high-pass: " + filterDialog.getHIGH();

	    if ( filterDialog.JRadioButtonLow.isSelected() )

	      return "low-pass: " + filterDialog.getLOW();

	    else

	      return "band-pass: " + filterDialog.getBAND1()+":"+filterDialog.getBAND2();

	}



	void filterMenuItem_actionPerformed(java.awt.event.ActionEvent event)

	{

		// apply filter

	    consol.textArea1.setText("");

	    DefaultMutableTreeNode[] nodes = getSelectedObject();

		if( nodes!=null ) ProcessDataFilter(nodes[0],true);

	}

	

	void PlotTraces(boolean filter_out) {

	    // Plot Traces

    if (filter_out == false)  

     previewPane.reset();

		DefaultMutableTreeNode[] SelectedNodes = getSelectedObject();

		if (SelectedNodes == null || SelectedNodes[0].getLevel()==0) return;

		SesameObject obj = (SesameObject)SelectedNodes[0].getUserObject();

		if( (obj.getType()==1 ) || (obj.getType()==2) ) {

		// preview

		

		if( filter_out) {

		 previewPane.loadWaveOnlyFilter(obj.getOutputFile()+"_SAF_fi");

     previewPane.setShowFilter(true);

    }

		else 

 		 previewPane.loadWaveOnly(obj.getName());

		previewPane.setWindows(obj.getSesameWindows());

		previewPane.setSpaceBetweenWindows(configManualWin.getOverlap());

		previewPane.setWindowLength(configManualWin.getWindowLength());

    System.out.println("plot");

		previewPane.plot();

		ACTIVE_OBJECT_PLOTED = SelectedNodes[0];

	    }

	}

	

	void createInputFileforFilter(SesameObject obj,String outfile) {

	       try 

     {

	    PrintWriter f = new PrintWriter(new BufferedWriter(new FileWriter(outfile)));



          f.print(obj.getName()+"  1     21  "+ obj.getWaveFormat());



            if (obj.getWaveFormat()== 1)

                f.println(" " + obj.getZname()+" "+ obj.getNSname()+" "+obj.getEWname()+" "+obj.getStationName());

            else

                f.println("");



      f.close();

     } catch (IOException Ex)

     {

     System.out.println(Ex.getMessage());

     }

	}



	void winFilterItem_actionPerformed(java.awt.event.ActionEvent event)

	{

		// window selection with filter

        this.processingSelectedNodes(true,true,true,true);			 

	}



	void winBothItem_actionPerformed(java.awt.event.ActionEvent event)

	{

		// window selection keeping common window

		DefaultMutableTreeNode ACTIVE_OBJECT_PLOTED_TEMP = ACTIVE_OBJECT_PLOTED;

		ACTIVE_OBJECT_PLOTED = null;

		this.processingSelectedNodes(true,true,false,true);

		this.processingSelectedNodes(true,false,true,true);

		ACTIVE_OBJECT_PLOTED = ACTIVE_OBJECT_PLOTED_TEMP;

		setCommonWindows();			 

	}



	void setCommonWindows() {

		DefaultMutableTreeNode[] nodes = getSelectedObject();

		if( nodes!=null ) {

		    int i=0;

		    while( nodes[i]!=null ) {

	          SesameObject obj = (SesameObject)nodes[i].getUserObject();	 

	          int j = 1;

	          int n = obj.getNumberWindows();

	          int m = obj.getNumberWindowsFilter();

	          int l;

	          while (j <= obj.getSesameWindows().getNumberWindows()) {

	            l=1;

	             while (l <= m) {

	              if( Math.abs( obj.getSesameWindowFirstIndex(j) - obj.getSesameWindowFirstIndexFilter(l))<3 ){

	               break;

	              }

	              ++l;

	             }

	            if( l > m ) obj.getSesameWindows().remove(j);

	            ++j;

	          }        

	          setWindows(obj.getSesameWindows(),nodes[i],false);

	          if(ACTIVE_OBJECT_PLOTED!=null) {

	           previewPane.setWindows(obj.getSesameWindows());

	           previewPane.plot();

	          }

	          ++i;

	        }

		}

	}





	void keepFirstWinforAllItem_actionPerformed(java.awt.event.ActionEvent event)

	{

		// keep the first window selection for the rest

		processingSelectedNodes(true,false,true,false);	 

	}



	void JEditOutFile_focusLost(java.awt.event.FocusEvent event)

	{

		// change outfile name

	/*	 DefaultMutableTreeNode[] nodes = getSelectedObject();

		if( nodes!=null ) {

		    SesameObject obj = (SesameObject)nodes[0].getUserObject();

		     obj.setOutputFile(JEditOutFile.getText());

		     nodes[0].setUserObject(obj);

		     model.reload(nodes[0]);

		}*/ 

	}

}

