package SesameGUI;

import Sesame2.singleWaveform;
import java.util.Vector;

public class AbstractFileReader
	{
	public boolean read()
		{
		return false;
		}

	public boolean readHeader()
		{
		return false;
		}

	public void setSpectra(singleWaveform w1 , singleWaveform w2 , singleWaveform w3)
		{
        copyWav (w1 , spectra1);
        copyWav (w2 , spectra2);
        copyWav (w3 , spectra3);
		}

	public void copyWav(singleWaveform w , Spectrum spectra)
		{
		spectra.setName(w.getChannelName());
		spectra.setStationName(w.getStationName());
		spectra.setSamplingRate(w.getSamplingFreq());
    spectra.setUnits(w.getUnits());

        Vector dp = w.getDataPoints();
        spectra.setValues(dp);
        /*dp = w.getDataPoints();
        count = w.getNumberPoints();
        for (i = 0 ; i < count ; i++)
            spectra.add (dp.elementAt(i));*/
		}

	protected Spectrum 	spectra1;
	protected Spectrum 	spectra2;
	protected Spectrum 	spectra3;
	}
