package Sesame2;
import java.util.Vector;
public class singleWaveform
{
  
  int year; // start time
  int month;
  int day;
  int hour;
  int minute;
  double sec;
  double sampRate; // sampling frequency
  private String channelName; // component name ( 'Z','N','E' )
  private String stationName;
  char amplitudeType; // amplitude type ( 'A','V','D','C' ) 
  Vector dataPoints; // points of the signal
  private String units;
  
	public singleWaveform()
	{    
	   year = 0; // start time
       month = 0;
       day = 0;
       hour = 0;
       minute = 0;
       sec = 0;
       sampRate = 0; // sampling frequency
       channelName = ""; // component name ( 'STAT Z','STAT N','STAT E' )
       amplitudeType = ' '; // amplitude type ( 'A','V','D','C' ) 
       dataPoints = new Vector(); // points of the signal
       units = new String();
	}
// getParameters	
	public int getYear() {
	    return year;
	}
	public int getMonth() {
	    return month;
	}
	public int getDay() {
	    return day;
	}
	public int getHour() {
	    return hour;
	}
	public int getMinute() {
	    return minute;
	}
	public double getSeconds() {
	    return sec;
	}
	public int getNumberPoints() {
	    return dataPoints.size();
	}
	public String getChannelName() {
	    return channelName;
	}
	
	public String getStationName() {
	    return stationName;
	}
	
	public double getSamplingFreq() {
	    return sampRate;
	}
	public char getAmplitudeType() {
	    return amplitudeType;
	}
	public Vector getDataPoints() {
	    return dataPoints;
	}
  public String getUnits()  {
      return units;  
  }

    // set parameters
   	public void setYear(int set_year) {
	    year = set_year;
	}
	public void setMonth(int set_month) {
	    month = set_month;
	}
	public void setDay(int set_day) {
	    day = set_day;
	}
	public void setHour(int set_hour) {
	    hour = set_hour;
	}
	public void setMinute(int set_minute) {
	    minute = set_minute;
	}
	public void setSeconds(double set_sec) {
	    sec = set_sec;
	}
	public void setChannelName(String set_channelName) {
	    channelName = set_channelName;
	}
	public void setStationName(String Name) {
	    stationName = Name;
	}
	public void setSamplingFreq(double set_sampRate) {
	    sampRate = set_sampRate;
	}
	
	public void setAmplitudeType(char set_ampType) {
	    amplitudeType = set_ampType;
	}
  public void setUnits(String un) {
	    units = un;
	}
	public void setDataPoints(Vector data) {
	    dataPoints =data;
	    /*int i;
	    dataPoints = new double[n];
	    for(i=0; i<n ; i++)
	     dataPoints[i]=data[i];
	    numberPoints = n;*/
	}


}