package SesameGUI;

import Sesame2.GSEFormatWaveform;
import Sesame2.singleWaveform;

public class GSEFileReader extends AbstractFileReader 
	{
	public GSEFileReader(String filename, Spectrum spectra1 , Spectrum spectra2 , Spectrum spectra3)
		{
		this.fileName = filename.replace('\"',' ');
    this.fileName = this.fileName.trim();

		this.spectra1 = spectra1;
		this.spectra2 = spectra2;
		this.spectra3 = spectra3;
		}

	public boolean read()
		{
		boolean ret;

		ret = false;

		try
			{
			GSEFormatWaveform		sw;

            		sw = new GSEFormatWaveform();

			if (sw.loadFile(this.fileName) == 0)
				{
				setSpectra (sw.getSingleTrace (0) , sw.getSingleTrace (1) , sw.getSingleTrace (2));
				ret = true;
				}
			}
		catch (Exception e)
			{
			}

		return ret;
		}

   public boolean readHeader()
		{
		boolean ret;

		ret = false;

		try
			{
			GSEFormatWaveform		sw;

            sw = new GSEFormatWaveform();

			if (sw.loadHeader(this.fileName) == 0)
				ret = true;
			}
		catch (Exception e)
			{
			}

		return ret;
		}
	private String 		fileName;
	}

