package SesameGUI;

public class IntField extends ValidatedField
	{
	public IntField(int defaultValue, int size)
		{
		super("" + defaultValue, size);
		}

	public boolean isValid()
		{
		boolean ret;
		String value;

		value = this.getText();

		ret = false;

		try
			{
			int i;

			i = Integer.parseInt(value);

			if (i >= minVal && i <= maxVal)
				ret = true;
			}
		catch (NumberFormatException e)
			{
			}

		return ret;
		}

	public int getMinVal()
		{
		return minVal;
		}

	public void setMinVal(int minVal)
		{
		this.minVal = minVal;
		}

	public int getMaxVal()
		{
		return maxVal;
		}

	public void setMaxVal(int maxVal)
		{
		this.maxVal = maxVal;
		}

	public boolean isBiggerThan(ValidatedField other)
		{
		boolean ret;

		ret = false;

		try
			{
			String value, valueRhs;

			value = this.getText();
			valueRhs = other.getText();

			if (Integer.parseInt(value) > Integer.parseInt(valueRhs))
				ret = true;
			}
		catch (NumberFormatException e)
			{
			}

		return ret;
		}

	private int minVal;
	private int maxVal;
	}


