package SesameGUI;

import java.awt.*;
import java.awt.geom.*;
import java.text.NumberFormat;

public class ScaleLabel extends javax.swing.JPanel
	{
	public ScaleLabel(SpectrumView view)
		{
		this.view = view;
		}

	public void paintComponent(Graphics g)
		{
		super.paintComponent(g);

		((Graphics2D)g).setPaint(new Color(0, 0, 0));

		int i;
		double offset;

		offset = getView().getWidth() / 5.0;

    NumberFormat formater = NumberFormat.getNumberInstance();
		formater.setMaximumFractionDigits(1);

		try
			{
			double l;
      double d;
			l = (getView().getScaleX().getUpperVisibleBound() - getView().getScaleX().getLowerVisibleBound()) / getView().getSpectrum(0).getSamplingRate() / getView().getSpectrum(0).getSamplingRate() / 5.0;
	
			for (i = 1; i <= 4; i++)
				{
        d = ((i * l) + (getView().getScaleX().getLowerVisibleBound() / getView().getSpectrum(0).getSamplingRate() / getView().getSpectrum(0).getSamplingRate()));
				((Graphics2D)g).drawString(Double.toString((int) d) , (int)((i * offset) - 10), 10);
				}
			}
		catch (Exception e)
			{
			}
		}

	public SpectrumView getView()
		{
		return view;
		}

	private SpectrumView view;
	}

