        subroutine reader_saf(data_file,
     #                     datath,maxsamp,deltat,n_samples,ier)
c
c
        implicit none
        integer  maxsamp, n_samples, ier
        real datath, deltat
        dimension datath(maxsamp,3)
        character data_file*200
c
        real sfre
        integer irow
c
      call rsaf(data_file,maxsamp,0,datath,n_samples,sfre,ier)
        if ( ier .eq. 0 )  deltat = 1./sfre
        if ( ier .eq. 2   .or.  ier .eq. 3) then
        write(*,*)' READER_SAF : this error should be impossible'
        write(*,*)'  problem in getting an unused fortran file unit'
        ier = 1
        endif
        if ( ier .eq. 4 ) then
        write(*,*)' READER_SAF : this file cannot be opened'
        write(*,100)data_file
        ier = 1
        endif
        if ( ier .eq. 7 ) then
        write(*,*)' READER_SAF : mandatory parameters are not ',
     #            'entirely set'
        write(*,100)data_file
        ier = 1
        endif
        if ( ier .eq. 8 ) then
        write(*,*)' READER_SAF : number of samples      : ', n_samples
        write(*,*)'        greater than dimension : ', maxsamp
        write(*,100)data_file
        ier = 1
        endif
        if ( ier .eq. 8 ) then
        write(*,*)' READER_SAF : error reading time histories data'
        write(*,100)data_file
        ier = 1
        endif
        if ( ier .eq. 50 ) then
        write(*,*)' READER_SAF : the opened file is NOT a current',
     #            '  version SAF'
        write(*,100)data_file
        ier = 2
        endif
        if ( ier .gt. 1000 ) then
        irow = ier - 1000
        write(*,*)' READER_SAF : problem reading line number :',irow
        write(*,100)data_file
        ier = 1
        endif
c
        return
c
100   format(1x,a200)
c
        end
