      subroutine readerthw(idfor,data_file,datath,maxsamp,n_samples,
     #                     deltat,idV,idN,idE,idsta,ier)
c
c read time history file 
c adapted from readerth
c
c format index : 0 = unknown 1 = gse, 2 = saf, 3 = cityshark 
c
        implicit none
c
        integer idfor, maxsamp, n_samples, ier
        real datath, deltat
        dimension datath(maxsamp,3)
        character data_file*200, idV*3,idN*3,idE*3,idsta*10
c
c
        ier = 0
c
c read file from disk
c 1 read GSE
        if     ( idfor  .eq.  1 ) then
        idV = ' '
        idN = ' '
        idE = ' '
        idsta = ' '
        call reader_gse(data_file,idV,idN,idE,
     #               idsta,datath,maxsamp,deltat,n_samples,ier)
        if ( ier .eq. 0      .or.       ier .eq. 1 ) return
c 2 read SAF
        elseif ( idfor  .eq.  2 ) then
        idV = ' '
        idN = ' '
        idE = ' '
        idsta = ' '
        call reader_saf(data_file,
     #                     datath,maxsamp,deltat,n_samples,ier)
        idV = 'Z'
        idN = 'NS'
        idE = 'EW'
        idsta = 'TEST'
        if ( ier .eq. 0      .or.       ier .eq. 1 ) return
c 3 read City Shark
      elseif ( idfor  .eq.  3  ) then
        idV = ' '
        idN = ' '
        idE = ' '
        idsta = ' '
      call reader_cs(data_file,
     #                     datath,maxsamp,deltat,n_samples,ier)
        idV = 'Z'
        idN = 'NS'
        idE = 'EW'
        idsta = 'TEST'
        if ( ier .eq. 0      .or.       ier .eq. 1 ) return
      endif
c        
c        
        idfor = 2
        idV = ' '
        idN = ' '
        idE = ' '
        idsta = ' '
      call reader_saf(data_file,
     #                     datath,maxsamp,deltat,n_samples,ier)
        idV = 'Z'
        idN = 'NS'
        idE = 'EW'
        idsta = 'TEST'
        if ( ier .eq. 0      .or.       ier .eq. 1 ) return
c        
        idfor = 3
        idV = ' '
        idN = ' '
        idE = ' '
        idsta = ' '
      call reader_cs(data_file,
     #                     datath,maxsamp,deltat,n_samples,ier)
        idV = 'Z'
        idN = 'NS'
        idE = 'EW'
        idsta = 'TEST'
        if ( ier .eq. 0      .or.       ier .eq. 1 ) return
c        
        idfor = 1
        idV = ' '
        idN = ' '
        idE = ' '
        idsta = ' '
      call reader_gse(data_file,idV,idN,idE,
     #               idsta,datath,maxsamp,deltat,n_samples,ier)
        if ( ier .eq. 0      .or.       ier .eq. 1 ) return
c
c 
      write(*,*)'  format NOT recognised for this file'
      write(*,100)data_file
      ier = 1
        return
c
100   format(1x,a200)
c
      end
